/*
	Copyright (c) 2000-2006 Michael Pozhidaev<msp@altlinux.org>. 
   This file is part of the VOICEMAN speech system.

   VOICEMAN speech system is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   VOICEMAN speech system is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
*/

#ifndef __VOICEMAN_H__
#define __VOICEMAN_H__

// Standart headers:
#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<string>
#include<vector>
#include<list>
#include<set>
#include<map>
#include<ext/hash_set>
#include<ext/hash_map>
#include<sstream>
#include<fstream>
#include<iostream>
#include<math.h>

// UNIX headers:
#include<sys/types.h>
#include<unistd.h>
#include<errno.h>
#include<assert.h>
#include<sys/stat.h>
#include<sys/wait.h>
#include<signal.h>
#include<sys/socket.h>
#include<arpa/inet.h>
#include<resolv.h>
#include<sys/un.h>
#include<pthread.h>
#include<fcntl.h>
#include<iconv.h>
#include<locale.h>
#include<time.h>

#include <ao/ao.h>

using std::vector;
using std::list;
using std::string;
using std::wstring;
using std::map;
using std::set;
using __gnu_cxx::hash_set;
using __gnu_cxx::hash_map;

#include"vmstring.h"
#include"vmconf.h"
#include"vmparam.h"
#include"logging.h"
#include"ptrs.h"
#include"cmdline.h"
#include"sockets.h"

bool read_text_file(const string &file_name, string &s);

#endif // __VOICEMAN_H__
